
import os
import string

class DirTreeElem:
    def __init__(self, name, level, isRoot, isLeaf):
        self.isRoot = False
        self.level = level
        self.parent = None
        self.name = name
        self.isLeaf = isLeaf

class DirTree:
    def __init__(self):
        self.elements = []
        element = DirTreeElem('/', 0, True, False)
        self.elements.append(element)
        self.maxLevel = 0
        
    def addNode(self, nodeName, level, isLeaf):
        element = DirTreeElem(nodeName, level, False, isLeaf)
        if not self._testNode(nodeName, level):
            self.elements.append(element)
            if self.maxLevel < level:
                self.maxLevel = level

    def _testNode(self, nodeName, level):
        for element in self.elements:
            if element.level==level and element.name==nodeName:
                return True
        return False
                
    def getAllLevel(self, level):
        retlist = []
        for elem in self.elements:
            if elem.level==level:
                retlist.append(elem)
        return retlist
        
    def sortTree(self):
        i = 0
        elemsorted = []
        while i <= self.maxLevel:
            elemsorted.append(self.getAllLevel(i))
            i = i + 1
        return elemsorted

def addPathToTree(filename, dirtree):
    (path, f) = os.path.split(filename)
    allpath = path.split('/')    
    i = 0    
    for pathpart in allpath[1:]:
        i=i+1
        dirtree.addNode(pathpart, i, False)        
    i = i + 1
    dirtree.addNode(f, i, True)
    

if __name__=="__main__":
    file1 = "/usr/share/guyum/gymain.py"
    file2 = "/usr/share/guyum/glade/guyum.glade"

    dirtree = DirTree()    
    addPathToTree(file1, dirtree)
    addPathToTree(file2, dirtree)
    
    elemsorted = dirtree.sortTree()
        
    print "ready"
    
    
